Linux ubuntu 6.8.0-90-generic #91-Ubuntu SMP PREEMPT_DYNAMIC Tue Nov 18 14:14:30 UTC 2025 x86_64
nginx/1.24.0
: 67.217.245.49 | : 216.73.216.153
Cant Read [ /etc/named.conf ]
8.3.6
www-data
Bypass.pw
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
Backdoor Scanner
Backdoor Create
Alfa Webshell
CPANEL RESET
CREATE WP USER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
NF
963
B
-rwxr-xr-x
VGAuthService
130.54
KB
-rwxr-xr-x
[
54.44
KB
-rwxr-xr-x
aa-enabled
18.3
KB
-rwxr-xr-x
aa-exec
18.3
KB
-rwxr-xr-x
aa-features-abi
18.3
KB
-rwxr-xr-x
ab
58.43
KB
-rwxr-xr-x
acpidbg
1.58
KB
-rwxr-xr-x
add-apt-repository
16.04
KB
-rwxr-xr-x
addpart
14.38
KB
-rwxr-xr-x
apport-bug
2.27
KB
-rwxr-xr-x
apport-cli
13.31
KB
-rwxr-xr-x
apport-collect
2.27
KB
-rwxr-xr-x
apport-unpack
3.7
KB
-rwxr-xr-x
appstreamcli
138.23
KB
-rwxr-xr-x
apropos
47.28
KB
-rwxr-xr-x
apt
18.38
KB
-rwxr-xr-x
apt-add-repository
16.04
KB
-rwxr-xr-x
apt-cache
86.47
KB
-rwxr-xr-x
apt-cdrom
26.47
KB
-rwxr-xr-x
apt-config
30.39
KB
-rwxr-xr-x
apt-extracttemplates
22.47
KB
-rwxr-xr-x
apt-ftparchive
222.48
KB
-rwxr-xr-x
apt-get
50.47
KB
-rwxr-xr-x
apt-key
27.99
KB
-rwxr-xr-x
apt-mark
54.47
KB
-rwxr-xr-x
apt-sortpkgs
50.4
KB
-rwxr-xr-x
arch
34.51
KB
-rwxr-xr-x
aria_chk
5.52
MB
-rwxr-xr-x
aria_dump_log
5.31
MB
-rwxr-xr-x
aria_ftdump
5.32
MB
-rwxr-xr-x
aria_pack
5.35
MB
-rwxr-xr-x
aria_read_log
5.48
MB
-rwxr-xr-x
aulast
18.3
KB
-rwxr-xr-x
aulastlog
14.3
KB
-rwxr-xr-x
ausyscall
14.3
KB
-rwxr-xr-x
automat-visualize3
984
B
-rwxr-xr-x
auvirt
38.38
KB
-rwxr-xr-x
awk
722.5
KB
-rwxr-xr-x
b2sum
54.51
KB
-rwxr-xr-x
base32
38.51
KB
-rwxr-xr-x
base64
38.51
KB
-rwxr-xr-x
basename
34.51
KB
-rwxr-xr-x
basenc
46.51
KB
-rwxr-xr-x
bash
1.38
MB
-rwxr-xr-x
bashbug
6.82
KB
-rwxr-xr-x
bc
90.82
KB
-rwxr-xr-x
boltctl
122.84
KB
-rwxr-xr-x
bpftrace
2.15
MB
-rwxr-xr-x
bpftrace-aotrt
985.37
KB
-rwxr-xr-x
btrfs
1001.25
KB
-rwxr-xr-x
btrfs-convert
576.3
KB
-rwxr-xr-x
btrfs-find-root
520.3
KB
-rwxr-xr-x
btrfs-image
552.3
KB
-rwxr-xr-x
btrfs-map-logical
520.3
KB
-rwxr-xr-x
btrfs-select-super
516.3
KB
-rwxr-xr-x
btrfsck
1001.25
KB
-rwxr-xr-x
btrfstune
544.3
KB
-rwxr-xr-x
busctl
94.59
KB
-rwxr-xr-x
busybox
2.03
MB
-rwxr-xr-x
byobu
8.5
KB
-rwxr-xr-x
byobu-config
996
B
-rwxr-xr-x
byobu-ctrl-a
4.66
KB
-rwxr-xr-x
byobu-disable
1.26
KB
-rwxr-xr-x
byobu-disable-prompt
1.31
KB
-rwxr-xr-x
byobu-enable
1.15
KB
-rwxr-xr-x
byobu-enable-prompt
1.42
KB
-rwxr-xr-x
byobu-export
1.39
KB
-rwxr-xr-x
byobu-janitor
7.04
KB
-rwxr-xr-x
byobu-keybindings
1.47
KB
-rwxr-xr-x
byobu-launch
3.25
KB
-rwxr-xr-x
byobu-launcher
1.87
KB
-rwxr-xr-x
byobu-launcher-install
2.47
KB
-rwxr-xr-x
byobu-launcher-uninstall
1.52
KB
-rwxr-xr-x
byobu-layout
3.27
KB
-rwxr-xr-x
byobu-prompt
1.13
KB
-rwxr-xr-x
byobu-quiet
1.38
KB
-rwxr-xr-x
byobu-reconnect-sockets
3.22
KB
-rwxr-xr-x
byobu-screen
8.5
KB
-rwxr-xr-x
byobu-select-backend
1.42
KB
-rwxr-xr-x
byobu-select-profile
5.06
KB
-rwxr-xr-x
byobu-select-session
1012
B
-rwxr-xr-x
byobu-shell
1.66
KB
-rwxr-xr-x
byobu-silent
1.28
KB
-rwxr-xr-x
byobu-status
5.87
KB
-rwxr-xr-x
byobu-status-detail
1.18
KB
-rwxr-xr-x
byobu-tmux
8.5
KB
-rwxr-xr-x
byobu-ugraph
4.56
KB
-rwxr-xr-x
byobu-ulevel
11.71
KB
-rwxr-xr-x
c_rehash
6.68
KB
-rwxr-xr-x
captoinfo
90.41
KB
-rwxr-xr-x
cat
38.46
KB
-rwxr-xr-x
catman
30.77
KB
-rwxr-xr-x
certbot
958
B
-rwxr-xr-x
cftp3
224
B
-rwxr-xr-x
cgi-fcgi
18.15
KB
-rwxr-xr-x
chage
70.49
KB
-rwxr-sr-x
chardet
221
B
-rwxr-xr-x
chardetect
221
B
-rwxr-xr-x
chattr
14.31
KB
-rwxr-xr-x
chcon
58.51
KB
-rwxr-xr-x
checkgid
14.3
KB
-rwxr-xr-x
chfn
71.09
KB
-rwsr-xr-x
chgrp
58.51
KB
-rwxr-xr-x
chmod
54.51
KB
-rwxr-xr-x
choom
22.38
KB
-rwxr-xr-x
chown
58.51
KB
-rwxr-xr-x
chrt
30.38
KB
-rwxr-xr-x
chsh
43.71
KB
-rwsr-xr-x
chvt
14.37
KB
-rwxr-xr-x
cifsiostat
26.45
KB
-rwxr-xr-x
ckbcomp
147.14
KB
-rwxr-xr-x
ckeygen3
227
B
-rwxr-xr-x
cksum
102.52
KB
-rwxr-xr-x
clambc
6.68
MB
-rwxr-xr-x
clamscan
162.38
KB
-rwxr-xr-x
clamsubmit
126.38
KB
-rwxr-xr-x
clear
14.31
KB
-rwxr-xr-x
clear_console
14.23
KB
-rwxr-xr-x
cloud-id
966
B
-rwxr-xr-x
cloud-init
970
B
-rwxr-xr-x
cloud-init-per
2.06
KB
-rwxr-xr-x
cmp
42.39
KB
-rwxr-xr-x
codepage
14.3
KB
-rwxr-xr-x
col
22.38
KB
-rwxr-xr-x
col1
963
B
-rwxr-xr-x
col2
963
B
-rwxr-xr-x
col3
963
B
-rwxr-xr-x
col4
963
B
-rwxr-xr-x
col5
963
B
-rwxr-xr-x
col6
963
B
-rwxr-xr-x
col7
963
B
-rwxr-xr-x
col8
963
B
-rwxr-xr-x
col9
963
B
-rwxr-xr-x
colcrt
14.38
KB
-rwxr-xr-x
colrm
14.38
KB
-rwxr-xr-x
column
38.38
KB
-rwxr-xr-x
comm
38.52
KB
-rwxr-xr-x
conch3
225
B
-rwxr-xr-x
corelist
15.01
KB
-rwxr-xr-x
cp
138.52
KB
-rwxr-xr-x
cpan
8.16
KB
-rwxr-xr-x
cpan5.38-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
cpio
137.67
KB
-rwxr-xr-x
cpupower
1.58
KB
-rwxr-xr-x
crontab
38.73
KB
-rwxr-sr-x
csplit
50.51
KB
-rwxr-xr-x
ctail
960
B
-rwxr-xr-x
ctstat
22.66
KB
-rwxr-xr-x
curl
290.32
KB
-rwxr-xr-x
cut
38.51
KB
-rwxr-xr-x
cvtsudoers
321.1
KB
-rwxr-xr-x
dash
126.74
KB
-rwxr-xr-x
date
106.51
KB
-rwxr-xr-x
dbilogstrip
1.35
KB
-rwxr-xr-x
dbiprof
6.06
KB
-rwxr-xr-x
dbiproxy
5.27
KB
-rwxr-xr-x
dbpmda
94.8
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.29
KB
-rwxr-xr-x
dbus-daemon
230.64
KB
-rwxr-xr-x
dbus-monitor
26.3
KB
-rwxr-xr-x
dbus-run-session
14.3
KB
-rwxr-xr-x
dbus-send
30.29
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.29
KB
-rwxr-xr-x
dbus-uuidgen
14.29
KB
-rwxr-xr-x
dbxtool
30.3
KB
-rwxr-xr-x
dd
70.54
KB
-rwxr-xr-x
deallocvt
14.37
KB
-rwxr-xr-x
deb-systemd-helper
23.79
KB
-rwxr-xr-x
deb-systemd-invoke
6.97
KB
-rwxr-xr-x
debconf
2.8
KB
-rwxr-xr-x
debconf-apt-progress
11.57
KB
-rwxr-xr-x
debconf-communicate
623
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
668
B
-rwxr-xr-x
debconf-set-selections
3.14
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debian-distro-info
30.95
KB
-rwxr-xr-x
delpart
14.38
KB
-rwxr-xr-x
delv
45.32
KB
-rwxr-xr-x
df
87.08
KB
-rwxr-xr-x
dh_bash-completion
4.42
KB
-rwxr-xr-x
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
dh_perl_dbi
1.17
KB
-rwxr-xr-x
diff
134.55
KB
-rwxr-xr-x
diff3
58.52
KB
-rwxr-xr-x
dig
150.83
KB
-rwxr-xr-x
dir
138.98
KB
-rwxr-xr-x
dircolors
46.52
KB
-rwxr-xr-x
dirmngr
473.77
KB
-rwxr-xr-x
dirmngr-client
54.92
KB
-rwxr-xr-x
dirname
34.38
KB
-rwxr-xr-x
distro-info
26.89
KB
-rwxr-xr-x
dmesg
68.64
KB
-rwxr-xr-x
dnsdomainname
22.23
KB
-rwxr-xr-x
do-release-upgrade
10.42
KB
-rwxr-xr-x
domainname
22.23
KB
-rwxr-xr-x
dpkg
310.72
KB
-rwxr-xr-x
dpkg-deb
142.58
KB
-rwxr-xr-x
dpkg-divert
118.57
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
dpkg-query
134.56
KB
-rwxr-xr-x
dpkg-realpath
4.09
KB
-rwxr-xr-x
dpkg-split
98.53
KB
-rwxr-xr-x
dpkg-statoverride
50.38
KB
-rwxr-xr-x
dpkg-trigger
42.53
KB
-rwxr-xr-x
dstat
74.98
KB
-rwxr-xr-x
du
98.51
KB
-rwxr-xr-x
dumpkeys
162.85
KB
-rwxr-xr-x
eatmydata
2.74
KB
-rwxr-xr-x
ec2metadata
8.38
KB
-rwxr-xr-x
echo
34.38
KB
-rwxr-xr-x
ed
58.55
KB
-rwxr-xr-x
editor
272.5
KB
-rwxr-xr-x
efibootdump
22.3
KB
-rwxr-xr-x
efibootmgr
47.69
KB
-rwxr-xr-x
egrep
41
B
-rwxr-xr-x
eject
42.23
KB
-rwxr-xr-x
enc2xs
40.96
KB
-rwxr-xr-x
encguess
3
KB
-rwxr-xr-x
env
46.95
KB
-rwxr-xr-x
envsubst
34.38
KB
-rwxr-xr-x
eqn
188.45
KB
-rwxr-xr-x
ex
3.94
MB
-rwxr-xr-x
expand
34.53
KB
-rwxr-xr-x
expiry
26.52
KB
-rwxr-sr-x
expr
42.41
KB
-rwxr-xr-x
factor
62.51
KB
-rwxr-xr-x
faillog
22.63
KB
-rwxr-xr-x
fallocate
26.38
KB
-rwxr-xr-x
false
26.3
KB
-rwxr-xr-x
fcgistarter
14.3
KB
-rwxr-xr-x
fgconsole
14.37
KB
-rwxr-xr-x
fgrep
41
B
-rwxr-xr-x
filan
50.48
KB
-rwxr-xr-x
file
30.6
KB
-rwxr-xr-x
finalrd
2.06
KB
-rwxr-xr-x
find
199.48
KB
-rwxr-xr-x
findmnt
67.66
KB
-rwxr-xr-x
flock
22.48
KB
-rwxr-xr-x
fmt
38.51
KB
-rwxr-xr-x
fold
34.51
KB
-rwxr-xr-x
free
26.38
KB
-rwxr-xr-x
freshclam
162.24
KB
-rwxr-xr-x
ftp
182.9
KB
-rwxr-xr-x
funzip
26.3
KB
-rwxr-xr-x
fuser
39.34
KB
-rwxr-xr-x
fusermount
38.38
KB
-rwsr-xr-x
fusermount3
38.38
KB
-rwsr-xr-x
fwupdmgr
118.3
KB
-rwxr-xr-x
fwupdtool
110.3
KB
-rwxr-xr-x
galera_new_cluster
917
B
-rwxr-xr-x
galera_recovery
3.29
KB
-rwxr-xr-x
gapplication
22.38
KB
-rwxr-xr-x
gawk
722.5
KB
-rwxr-xr-x
gawkbug
6.74
KB
-rwxr-xr-x
gdbus
50.38
KB
-rwxr-xr-x
gencat
26.44
KB
-rwxr-xr-x
genpmda
29.17
KB
-rwxr-xr-x
geqn
188.45
KB
-rwxr-xr-x
getconf
26.36
KB
-rwxr-xr-x
getent
38.72
KB
-rwxr-xr-x
getkeycodes
14.37
KB
-rwxr-xr-x
getopt
22.38
KB
-rwxr-xr-x
gettext
34.38
KB
-rwxr-xr-x
gettext.sh
5.07
KB
-rwxr-xr-x
ginstall-info
47.24
KB
-rwxr-xr-x
gio
102.4
KB
-rwxr-xr-x
gio-querymodules
18.3
KB
-rwxr-xr-x
git
3.88
MB
-rwxr-xr-x
git-receive-pack
3.88
MB
-rwxr-xr-x
git-shell
624.81
KB
-rwxr-xr-x
git-upload-archive
3.88
MB
-rwxr-xr-x
git-upload-pack
3.88
MB
-rwxr-xr-x
glib-compile-schemas
54.3
KB
-rwxr-xr-x
gpasswd
74.46
KB
-rwsr-xr-x
gpg
1.09
MB
-rwxr-xr-x
gpg-agent
357.52
KB
-rwxr-xr-x
gpg-connect-agent
87.3
KB
-rwxr-xr-x
gpg-wks-client
139.37
KB
-rwxr-xr-x
gpgconf
115.36
KB
-rwxr-xr-x
gpgparsemail
34.38
KB
-rwxr-xr-x
gpgsm
501.37
KB
-rwxr-xr-x
gpgsplit
26.62
KB
-rwxr-xr-x
gpgtar
67.83
KB
-rwxr-xr-x
gpgv
303.14
KB
-rwxr-xr-x
gpic
196.06
KB
-rwxr-xr-x
grep
182.45
KB
-rwxr-xr-x
gresource
22.3
KB
-rwxr-xr-x
groff
94.51
KB
-rwxr-xr-x
grog
18.75
KB
-rwxr-xr-x
grops
162.55
KB
-rwxr-xr-x
grotty
118.51
KB
-rwxr-xr-x
groups
34.51
KB
-rwxr-xr-x
growpart
29.19
KB
-rwxr-xr-x
grub-editenv
393.16
KB
-rwxr-xr-x
grub-file
741.88
KB
-rwxr-xr-x
grub-fstest
863.32
KB
-rwxr-xr-x
grub-glue-efi
102.88
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
83.2
KB
-rwxr-xr-x
grub-mkfont
131.45
KB
-rwxr-xr-x
grub-mkimage
377.26
KB
-rwxr-xr-x
grub-mklayout
103.23
KB
-rwxr-xr-x
grub-mknetdir
429.77
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
111.32
KB
-rwxr-xr-x
grub-mkrelpath
259.79
KB
-rwxr-xr-x
grub-mkrescue
1019.84
KB
-rwxr-xr-x
grub-mkstandalone
510.16
KB
-rwxr-xr-x
grub-mount
682.21
KB
-rwxr-xr-x
grub-ntldr-img
38.39
KB
-rwxr-xr-x
grub-render-label
750.23
KB
-rwxr-xr-x
grub-script-check
126.76
KB
-rwxr-xr-x
grub-syslinux2cfg
698.71
KB
-rwxr-xr-x
gsettings
30.3
KB
-rwxr-xr-x
gtbl
134.48
KB
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
91.23
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.51
KB
-rwxr-xr-x
hardlink
46.48
KB
-rwxr-xr-x
hd
46.39
KB
-rwxr-xr-x
head
42.51
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
46.39
KB
-rwxr-xr-x
host
118.82
KB
-rwxr-xr-x
hostid
34.51
KB
-rwxr-xr-x
hostname
22.23
KB
-rwxr-xr-x
hostnamectl
30.45
KB
-rwxr-xr-x
htcacheclean
34.31
KB
-rwxr-xr-x
htdbm
26.3
KB
-rwxr-xr-x
htdigest
14.3
KB
-rwxr-xr-x
htop
370.33
KB
-rwxr-xr-x
htpasswd
26.3
KB
-rwxr-xr-x
hwe-support-status
11.24
KB
-rwxr-xr-x
i386
26.65
KB
-rwxr-xr-x
iconv
66.48
KB
-rwxr-xr-x
id
38.51
KB
-rwxr-xr-x
ifstat
34.31
KB
-rwxr-xr-x
inetutils-telnet
177.85
KB
-rwxr-xr-x
info
241.73
KB
-rwxr-xr-x
infobrowser
241.73
KB
-rwxr-xr-x
infocmp
66.38
KB
-rwxr-xr-x
infotocap
90.41
KB
-rwxr-xr-x
innochecksum
4.57
MB
-rwxr-xr-x
innotop
445.71
KB
-rwxr-xr-x
install
142.52
KB
-rwxr-xr-x
install-info
47.24
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
18.38
KB
-rwxr-xr-x
iostat
54.44
KB
-rwxr-xr-x
ip
754.8
KB
-rwxr-xr-x
ipcmk
22.45
KB
-rwxr-xr-x
ipcrm
18.38
KB
-rwxr-xr-x
ipcs
38.38
KB
-rwxr-xr-x
iperf3
14.15
KB
-rwxr-xr-x
iptables-xml
92.95
KB
-rwxr-xr-x
ischroot
14.48
KB
-rwxr-xr-x
iscsiadm
370.43
KB
-rwxr-xr-x
join
50.55
KB
-rwxr-xr-x
journalctl
78.91
KB
-rwxr-xr-x
jq
30.15
KB
-rwxr-xr-x
json-patch-jsondiff
1004
B
-rwxr-xr-x
json_pp
4.88
KB
-rwxr-xr-x
jsondiff
1004
B
-rwxr-xr-x
jsonpatch
3.77
KB
-rwxr-xr-x
jsonpointer
1.79
KB
-rwxr-xr-x
jsonschema
213
B
-rwxr-xr-x
kbd_mode
14.66
KB
-rwxr-xr-x
kbdinfo
18.37
KB
-rwxr-xr-x
kbxutil
62.83
KB
-rwxr-xr-x
keep-one-running
3.51
KB
-rwxr-xr-x
kernel-install
54.67
KB
-rwxr-xr-x
kill
22.38
KB
-rwxr-xr-x
killall
31.34
KB
-rwxr-xr-x
kmod
170.24
KB
-rwxr-xr-x
kmodsign
18.45
KB
-rwxr-xr-x
landscape-sysinfo
646
B
-rwxr-xr-x
last
34.38
KB
-rwxr-xr-x
lastb
34.38
KB
-rwxr-xr-x
lastlog
27.79
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld.so
231.07
KB
-rwxr-xr-x
ldd
5.26
KB
-rwxr-xr-x
less
190.38
KB
-rwxr-xr-x
lessecho
14.31
KB
-rwxr-xr-x
lessfile
8.83
KB
-rwxr-xr-x
lesskey
23.7
KB
-rwxr-xr-x
lesspipe
8.83
KB
-rwxr-xr-x
letsencrypt
958
B
-rwxr-xr-x
lexgrog
99.51
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
link
34.51
KB
-rwxr-xr-x
linux-boot-prober
1.54
KB
-rwxr-xr-x
linux-check-removal
3.99
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
26.65
KB
-rwxr-xr-x
linux64
26.65
KB
-rwxr-xr-x
ln
54.51
KB
-rwxr-xr-x
lnstat
22.66
KB
-rwxr-xr-x
loadkeys
202.9
KB
-rwxr-xr-x
loadunimap
34.46
KB
-rwxr-xr-x
locale
49.63
KB
-rwxr-xr-x
locale-check
14.15
KB
-rwxr-xr-x
localectl
26.45
KB
-rwxr-xr-x
localedef
319.09
KB
-rwxr-xr-x
logger
38.97
KB
-rwxr-xr-x
login
51.81
KB
-rwxr-xr-x
loginctl
66.58
KB
-rwxr-xr-x
logname
34.51
KB
-rwxr-xr-x
logresolve
14.31
KB
-rwxr-xr-x
look
18.38
KB
-rwxr-xr-x
lowntfs-3g
118.98
KB
-rwxr-xr-x
ls
138.98
KB
-rwxr-xr-x
lsattr
14.31
KB
-rwxr-xr-x
lsb_release
2.59
KB
-rwxr-xr-x
lsblk
146.38
KB
-rwxr-xr-x
lscpu
110.38
KB
-rwxr-xr-x
lshw
957.2
KB
-rwxr-xr-x
lsinitramfs
735
B
-rwxr-xr-x
lsipc
50.38
KB
-rwxr-xr-x
lslocks
30.77
KB
-rwxr-xr-x
lslogins
50.38
KB
-rwxr-xr-x
lsmem
38.38
KB
-rwxr-xr-x
lsmod
170.24
KB
-rwxr-xr-x
lsns
42.38
KB
-rwxr-xr-x
lsof
171.66
KB
-rwxr-xr-x
lspci
100.11
KB
-rwxr-xr-x
lspgpot
1.06
KB
-rwxr-xr-x
lspower
1.18
KB
-rwxr-xr-x
lsusb
246.52
KB
-rwxr-xr-x
lzcat
86.92
KB
-rwxr-xr-x
lzcmp
7.25
KB
-rwxr-xr-x
lzdiff
7.25
KB
-rwxr-xr-x
lzegrep
10.09
KB
-rwxr-xr-x
lzfgrep
10.09
KB
-rwxr-xr-x
lzgrep
10.09
KB
-rwxr-xr-x
lzless
1.77
KB
-rwxr-xr-x
lzma
86.92
KB
-rwxr-xr-x
lzmainfo
14.38
KB
-rwxr-xr-x
lzmore
2.14
KB
-rwxr-xr-x
mailmail3
227
B
-rwxr-xr-x
man
125.41
KB
-rwxr-xr-x
man-recode
35.4
KB
-rwxr-xr-x
mandb
143.67
KB
-rwxr-xr-x
manifest
1.9
KB
-rwxr-xr-x
manpath
26.78
KB
-rwxr-xr-x
mapscrn
30.46
KB
-rwxr-xr-x
mariadb
5.07
MB
-rwxr-xr-x
mariadb-access
109.31
KB
-rwxr-xr-x
mariadb-admin
4.85
MB
-rwxr-xr-x
mariadb-analyze
4.84
MB
-rwxr-xr-x
mariadb-binlog
5.13
MB
-rwxr-xr-x
mariadb-check
4.84
MB
-rwxr-xr-x
mariadb-conv
4.56
MB
-rwxr-xr-x
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
mariadb-dump
4.93
MB
-rwxr-xr-x
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
mariadb-find-rows
3.21
KB
-rwxr-xr-x
mariadb-fix-extensions
1.22
KB
-rwxr-xr-x
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
mariadb-import
4.83
MB
-rwxr-xr-x
mariadb-install-db
22.13
KB
-rwxr-xr-x
mariadb-optimize
4.84
MB
-rwxr-xr-x
mariadb-plugin
4.54
MB
-rwxr-xr-x
mariadb-repair
4.84
MB
-rwxr-xr-x
mariadb-report
49.02
KB
-rwxr-xr-x
mariadb-secure-installation
13.49
KB
-rwxr-xr-x
mariadb-service-convert
2.45
KB
-rwxr-xr-x
mariadb-setpermission
17.56
KB
-rwxr-xr-x
mariadb-show
4.83
MB
-rwxr-xr-x
mariadb-slap
4.85
MB
-rwxr-xr-x
mariadb-tzinfo-to-sql
4.53
MB
-rwxr-xr-x
mariadb-upgrade
4.97
MB
-rwxr-xr-x
mariadb-waitpid
4.53
MB
-rwxr-xr-x
mariadbcheck
4.84
MB
-rwxr-xr-x
mariadbd-multi
26.69
KB
-rwxr-xr-x
mariadbd-safe
30.42
KB
-rwxr-xr-x
mariadbd-safe-helper
4.49
MB
-rwxr-xr-x
markdown-it
220
B
-rwxr-xr-x
mawk
166.77
KB
-rwxr-xr-x
mbim-network
11.08
KB
-rwxr-xr-x
mbimcli
216.65
KB
-rwxr-xr-x
mcookie
26.45
KB
-rwxr-xr-x
md5sum
38.41
KB
-rwxr-xr-x
md5sum.textutils
38.41
KB
-rwxr-xr-x
mdig
50.4
KB
-rwxr-xr-x
memhog
14.42
KB
-rwxr-xr-x
memusage
7.32
KB
-rwxr-xr-x
memusagestat
22.44
KB
-rwxr-xr-x
mesg
14.38
KB
-rwxr-xr-x
migrate-pubring-from-classic-g...
3.02
KB
-rwxr-xr-x
migratepages
14.38
KB
-rwxr-xr-x
migspeed
14.3
KB
-rwxr-xr-x
mk_modmap
15.78
KB
-rwxr-xr-x
mkdir
74.51
KB
-rwxr-xr-x
mkfifo
42.51
KB
-rwxr-xr-x
mknod
42.51
KB
-rwxr-xr-x
mkpasswd
26.38
KB
-rwxr-xr-x
mksquashfs
286.95
KB
-rwxr-xr-x
mktemp
34.51
KB
-rwxr-xr-x
mmcli
273.94
KB
-rwxr-xr-x
mokutil
59.48
KB
-rwxr-xr-x
more
46.38
KB
-rwxr-xr-x
mount
50.38
KB
-rwsr-xr-x
mountpoint
18.38
KB
-rwxr-xr-x
mpstat
50.45
KB
-rwxr-xr-x
msql2mysql
1.41
KB
-rwxr-xr-x
mt
70.73
KB
-rwxr-xr-x
mt-gnu
70.73
KB
-rwxr-xr-x
mtr
76.25
KB
-rwxr-xr-x
mtr-packet
34.3
KB
-rwxr-xr-x
mtrace
6.37
KB
-rwxr-xr-x
mv
134.52
KB
-rwxr-xr-x
my_print_defaults
4.53
MB
-rwxr-xr-x
myisam_ftdump
4.87
MB
-rwxr-xr-x
myisamchk
4.99
MB
-rwxr-xr-x
myisamlog
4.85
MB
-rwxr-xr-x
myisampack
4.9
MB
-rwxr-xr-x
mysql
5.07
MB
-rwxr-xr-x
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
mysql_find_rows
3.21
KB
-rwxr-xr-x
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
mysql_install_db
22.13
KB
-rwxr-xr-x
mysql_plugin
4.54
MB
-rwxr-xr-x
mysql_secure_installation
13.49
KB
-rwxr-xr-x
mysql_setpermission
17.56
KB
-rwxr-xr-x
mysql_tzinfo_to_sql
4.53
MB
-rwxr-xr-x
mysql_upgrade
4.97
MB
-rwxr-xr-x
mysql_waitpid
4.53
MB
-rwxr-xr-x
mysqlaccess
109.31
KB
-rwxr-xr-x
mysqladmin
4.85
MB
-rwxr-xr-x
mysqlanalyze
4.84
MB
-rwxr-xr-x
mysqlbinlog
5.13
MB
-rwxr-xr-x
mysqlcheck
4.84
MB
-rwxr-xr-x
mysqld_multi
26.69
KB
-rwxr-xr-x
mysqld_safe
30.42
KB
-rwxr-xr-x
mysqld_safe_helper
4.49
MB
-rwxr-xr-x
mysqldump
4.93
MB
-rwxr-xr-x
mysqldumpslow
8.05
KB
-rwxr-xr-x
mysqlhotcopy
34.53
KB
-rwxr-xr-x
mysqlimport
4.83
MB
-rwxr-xr-x
mysqloptimize
4.84
MB
-rwxr-xr-x
mysqlrepair
4.84
MB
-rwxr-xr-x
mysqlreport
49.02
KB
-rwxr-xr-x
mysqlshow
4.83
MB
-rwxr-xr-x
mysqlslap
4.85
MB
-rwxr-xr-x
mytop
71.95
KB
-rwxr-xr-x
namei
22.38
KB
-rwxr-xr-x
nano
272.5
KB
-rwxr-xr-x
nawk
722.5
KB
-rwxr-xr-x
nc
38.63
KB
-rwxr-xr-x
nc.openbsd
38.63
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netaddr
959
B
-rwxr-xr-x
netcat
38.63
KB
-rwxr-xr-x
netstat
154.59
KB
-rwxr-xr-x
networkctl
122.58
KB
-rwxr-xr-x
networkd-dispatcher
19.88
KB
-rwxr-xr-x
newgrp
39.71
KB
-rwsr-xr-x
ngettext
34.38
KB
-rwxr-xr-x
nice
34.51
KB
-rwxr-xr-x
nisdomainname
22.23
KB
-rwxr-xr-x
nl
38.6
KB
-rwxr-xr-x
nohup
34.41
KB
-rwxr-xr-x
nproc
34.51
KB
-rwxr-xr-x
nroff
5.58
KB
-rwxr-xr-x
nsenter
30.6
KB
-rwxr-xr-x
nslookup
122.82
KB
-rwxr-xr-x
nstat
30.38
KB
-rwxr-xr-x
nsupdate
74.55
KB
-rwxr-xr-x
ntfs-3g
159.01
KB
-rwxr-xr-x
ntfs-3g.probe
14.38
KB
-rwxr-xr-x
ntfscat
26.38
KB
-rwxr-xr-x
ntfscluster
38.38
KB
-rwxr-xr-x
ntfscmp
30.38
KB
-rwxr-xr-x
ntfsdecrypt
42.38
KB
-rwxr-xr-x
ntfsfallocate
26.38
KB
-rwxr-xr-x
ntfsfix
34.38
KB
-rwxr-xr-x
ntfsinfo
54.38
KB
-rwxr-xr-x
ntfsls
27.45
KB
-rwxr-xr-x
ntfsmove
30.38
KB
-rwxr-xr-x
ntfsrecover
102.38
KB
-rwxr-xr-x
ntfssecaudit
78.86
KB
-rwxr-xr-x
ntfstruncate
26.3
KB
-rwxr-xr-x
ntfsusermap
18.3
KB
-rwxr-xr-x
ntfswipe
46.91
KB
-rwxr-xr-x
numactl
35.23
KB
-rwxr-xr-x
numastat
35.56
KB
-rwxr-xr-x
numfmt
58.54
KB
-rwxr-xr-x
od
70.51
KB
-rwxr-xr-x
oem-getlogs
8.3
KB
-rwxr-xr-x
on_ac_power
3.7
KB
-rwxr-xr-x
openssl
981.8
KB
-rwxr-xr-x
openvt
22.73
KB
-rwxr-xr-x
os-prober
4.42
KB
-rwxr-xr-x
pager
190.38
KB
-rwxr-xr-x
partx
62.38
KB
-rwxr-xr-x
passwd
62.65
KB
-rwsr-xr-x
paste
38.41
KB
-rwxr-xr-x
pastebinit
16.31
KB
-rwxr-xr-x
patch
182.52
KB
-rwxr-xr-x
pathchk
34.51
KB
-rwxr-xr-x
pbget
2.51
KB
-rwxr-xr-x
pbput
2.51
KB
-rwxr-xr-x
pbputs
2.51
KB
-rwxr-xr-x
pcp
5.3
KB
-rwxr-xr-x
pcp2csv
65.89
KB
-rwxr-xr-x
pdb3
67.83
KB
-rwxr-xr-x
pdb3.12
67.83
KB
-rwxr-xr-x
peekfd
14.3
KB
-rwxr-xr-x
perf
1.58
KB
-rwxr-xr-x
perl
3.83
MB
-rwxr-xr-x
perl5.38-x86_64-linux-gnu
14.3
KB
-rwxr-xr-x
perl5.38.2
3.83
MB
-rwxr-xr-x
perlbug
44.52
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
44.52
KB
-rwxr-xr-x
perror
4.72
MB
-rwxr-xr-x
pgrep
34.47
KB
-rwxr-xr-x
phar
14.84
KB
-rwxr-xr-x
phar.default
14.84
KB
-rwxr-xr-x
phar.phar
14.84
KB
-rwxr-xr-x
phar.phar.default
14.84
KB
-rwxr-xr-x
phar.phar8.3
14.84
KB
-rwxr-xr-x
phar8.3
14.84
KB
-rwxr-xr-x
phar8.3.phar
14.84
KB
-rwxr-xr-x
php
5.52
MB
-rwxr-xr-x
php.default
5.52
MB
-rwxr-xr-x
php8.3
5.52
MB
-rwxr-xr-x
pic
196.06
KB
-rwxr-xr-x
pico
272.5
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.23
KB
-rwxr-xr-x
pidstat
50.45
KB
-rwxr-xr-x
pidwait
34.47
KB
-rwxr-xr-x
pinentry
58.65
KB
-rwxr-xr-x
pinentry-curses
58.65
KB
-rwxr-xr-x
ping
87.7
KB
-rwxr-xr-x
ping4
87.7
KB
-rwxr-xr-x
ping6
87.7
KB
-rwxr-xr-x
pinky
38.41
KB
-rwxr-xr-x
pkaction
18.3
KB
-rwxr-xr-x
pkcheck
22.3
KB
-rwxr-xr-x
pkcon
54.3
KB
-rwxr-xr-x
pkill
34.47
KB
-rwxr-xr-x
pkmon
22.3
KB
-rwxr-xr-x
pkttyagent
22.3
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.44
KB
-rwxr-xr-x
plymouth
46.3
KB
-rwxr-xr-x
pmafm
11.84
KB
-rwxr-xr-x
pmap
34.4
KB
-rwxr-xr-x
pmclient
22.92
KB
-rwxr-xr-x
pmclient_fg
18.91
KB
-rwxr-xr-x
pmdate
14.02
KB
-rwxr-xr-x
pmdbg
22.58
KB
-rwxr-xr-x
pmdiff
7.63
KB
-rwxr-xr-x
pmdumplog
35.13
KB
-rwxr-xr-x
pmerr
14.02
KB
-rwxr-xr-x
pmevent
43.38
KB
-rwxr-xr-x
pmfind
22.7
KB
-rwxr-xr-x
pmgenmap
2.38
KB
-rwxr-xr-x
pmie
197.95
KB
-rwxr-xr-x
pmie2col
2.81
KB
-rwxr-xr-x
pmieconf
56.77
KB
-rwxr-xr-x
pmiectl
46
KB
-rwxr-xr-x
pminfo
47.29
KB
-rwxr-xr-x
pmiostat
20.79
KB
-rwxr-xr-x
pmjson
14.63
KB
-rwxr-xr-x
pmlc
55.86
KB
-rwxr-xr-x
pmlogcheck
38.7
KB
-rwxr-xr-x
pmlogconf
55.26
KB
-rwxr-xr-x
pmlogctl
46
KB
-rwxr-xr-x
pmlogdump
35.13
KB
-rwxr-xr-x
pmlogextract
74.88
KB
-rwxr-xr-x
pmlogger
159.62
KB
-rwxr-xr-x
pmloglabel
22.63
KB
-rwxr-xr-x
pmlogmv
18.54
KB
-rwxr-xr-x
pmlogpaste
18.57
KB
-rwxr-xr-x
pmlogredact
1.79
KB
-rwxr-xr-x
pmlogreduce
30.7
KB
-rwxr-xr-x
pmlogrewrite
158.76
KB
-rwxr-xr-x
pmlogsize
26.54
KB
-rwxr-xr-x
pmlogsummary
35.13
KB
-rwxr-xr-x
pmprobe
23.04
KB
-rwxr-xr-x
pmpython
14.02
KB
-rwxr-xr-x
pmrep
65.89
KB
-rwxr-xr-x
pmrepconf
55.26
KB
-rwxr-xr-x
pmsearch
22.91
KB
-rwxr-xr-x
pmseries
39.16
KB
-rwxr-xr-x
pmsocks
1010
B
-rwxr-xr-x
pmstat
27.07
KB
-rwxr-xr-x
pmstore
18.7
KB
-rwxr-xr-x
pmtrace
14.02
KB
-rwxr-xr-x
pmval
43.38
KB
-rwxr-xr-x
pod2html
3.95
KB
-rwxr-xr-x
pod2man
18.46
KB
-rwxr-xr-x
pod2text
12.8
KB
-rwxr-xr-x
pod2usage
4.01
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
pollinate
8.54
KB
-rwxr-xr-x
pr
70.58
KB
-rwxr-xr-x
preconv
58.48
KB
-rwxr-xr-x
printenv
34.38
KB
-rwxr-xr-x
printf
54.44
KB
-rwxr-xr-x
prlimit
26.89
KB
-rwxr-xr-x
pro
1003
B
-rwxr-xr-x
procan
42.41
KB
-rwxr-xr-x
prove
13.34
KB
-rwxr-xr-x
prtstat
18.38
KB
-rwxr-xr-x
ps
142.99
KB
-rwxr-xr-x
psfaddtable
22.37
KB
-rwxr-xr-x
psfgettable
22.37
KB
-rwxr-xr-x
psfstriptable
22.37
KB
-rwxr-xr-x
psfxtable
22.37
KB
-rwxr-xr-x
pslog
14.3
KB
-rwxr-xr-x
pstree
35.32
KB
-rwxr-xr-x
pstree.x11
35.32
KB
-rwxr-xr-x
ptar
3.48
KB
-rwxr-xr-x
ptardiff
2.58
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
54.54
KB
-rwxr-xr-x
purge-old-kernels
1.12
KB
-rwxr-xr-x
pv
79.41
KB
-rwxr-xr-x
pwd
34.51
KB
-rwxr-xr-x
pwdx
14.38
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
13
KB
-rwxr-xr-x
py3versions
12.52
KB
-rwxr-xr-x
pybabel
956
B
-rwxr-xr-x
pybabel-python3
956
B
-rwxr-xr-x
pydoc3
80
B
-rwxr-xr-x
pydoc3.12
80
B
-rwxr-xr-x
pygettext3
23.66
KB
-rwxr-xr-x
pygettext3.12
23.66
KB
-rwxr-xr-x
pygmentize
215
B
-rwxr-xr-x
pyhtmlizer3
222
B
-rwxr-xr-x
pyserial-miniterm
975
B
-rwxr-xr-x
pyserial-ports
969
B
-rwxr-xr-x
python3
7.65
MB
-rwxr-xr-x
python3.12
7.65
MB
-rwxr-xr-x
pzstd
690.54
KB
-rwxr-xr-x
qmi-firmware-update
168.09
KB
-rwxr-xr-x
qmi-network
16.04
KB
-rwxr-xr-x
qmicli
586.84
KB
-rwxr-xr-x
rbash
1.38
MB
-rwxr-xr-x
rdma
102.52
KB
-rwxr-xr-x
readlink
42.41
KB
-rwxr-xr-x
realpath
42.41
KB
-rwxr-xr-x
red
89
B
-rwxr-xr-x
rename.ul
22.38
KB
-rwxr-xr-x
renice
14.38
KB
-rwxr-xr-x
replace
4.51
MB
-rwxr-xr-x
rescan-scsi-bus.sh
38.05
KB
-rwxr-xr-x
reset
26.31
KB
-rwxr-xr-x
resizecons
26.46
KB
-rwxr-xr-x
resizepart
22.38
KB
-rwxr-xr-x
resolve_stack_dump
4.53
MB
-rwxr-xr-x
resolvectl
158.67
KB
-rwxr-xr-x
resolveip
4.53
MB
-rwxr-xr-x
rev
14.38
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rm
58.51
KB
-rwxr-xr-x
rmdir
46.41
KB
-rwxr-xr-x
rnano
272.5
KB
-rwxr-xr-x
rotatelogs
26.38
KB
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
94.59
KB
-rwxr-xr-x
rrsync
12.34
KB
-rwxr-xr-x
rsync
502.13
KB
-rwxr-xr-x
rsync-ssl
5.02
KB
-rwxr-xr-x
rtla
1.58
KB
-rwxr-xr-x
rtstat
22.66
KB
-rwxr-xr-x
run-one
3.51
KB
-rwxr-xr-x
run-one-constantly
3.51
KB
-rwxr-xr-x
run-one-until-failure
3.51
KB
-rwxr-xr-x
run-one-until-success
3.51
KB
-rwxr-xr-x
run-parts
26.82
KB
-rwxr-xr-x
run-this-one
3.51
KB
-rwxr-xr-x
runcon
34.51
KB
-rwxr-xr-x
rview
3.94
MB
-rwxr-xr-x
rvim
3.94
MB
-rwxr-xr-x
sadf
382.31
KB
-rwxr-xr-x
sar
137.38
KB
-rwxr-xr-x
sar.sysstat
137.38
KB
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
sbattach
22.54
KB
-rwxr-xr-x
sbkeysync
34.74
KB
-rwxr-xr-x
sbsiglist
14.6
KB
-rwxr-xr-x
sbsign
34.7
KB
-rwxr-xr-x
sbvarsign
22.73
KB
-rwxr-xr-x
sbverify
30.61
KB
-rwxr-xr-x
scalar
668.94
KB
-rwxr-xr-x
scandeps
6.47
KB
-rwxr-xr-x
scp
134.59
KB
-rwxr-xr-x
screen
478.24
KB
-rwxr-xr-x
screendump
14.3
KB
-rwxr-xr-x
script
54.38
KB
-rwxr-xr-x
scriptlive
42.38
KB
-rwxr-xr-x
scriptreplay
34.38
KB
-rwxr-xr-x
scsi_logging_level
8.38
KB
-rwxr-xr-x
scsi_mandat
3.52
KB
-rwxr-xr-x
scsi_readcap
1.3
KB
-rwxr-xr-x
scsi_ready
1.09
KB
-rwxr-xr-x
scsi_satl
3.74
KB
-rwxr-xr-x
scsi_start
1.25
KB
-rwxr-xr-x
scsi_stop
1.44
KB
-rwxr-xr-x
scsi_temperature
936
B
-rwxr-xr-x
sdiff
50.39
KB
-rwxr-xr-x
sed
110.57
KB
-rwxr-xr-x
select-editor
2.39
KB
-rwxr-xr-x
sensible-browser
1.55
KB
-rwxr-xr-x
sensible-editor
1.52
KB
-rwxr-xr-x
sensible-pager
921
B
-rwxr-xr-x
sensible-terminal
1.15
KB
-rwxr-xr-x
seq
50.51
KB
-rwxr-xr-x
setarch
26.65
KB
-rwxr-xr-x
setfont
54.46
KB
-rwxr-xr-x
setkeycodes
14.37
KB
-rwxr-xr-x
setleds
18.43
KB
-rwxr-xr-x
setlogcons
14.37
KB
-rwxr-xr-x
setmetamode
14.41
KB
-rwxr-xr-x
setpci
30.38
KB
-rwxr-xr-x
setpriv
38.38
KB
-rwxr-xr-x
setsid
14.38
KB
-rwxr-xr-x
setterm
34.38
KB
-rwxr-xr-x
setupcon
40.06
KB
-rwxr-xr-x
sftp
150.66
KB
-rwxr-xr-x
sg
39.71
KB
-rwsr-xr-x
sg_bg_ctl
14.51
KB
-rwxr-xr-x
sg_compare_and_write
26.91
KB
-rwxr-xr-x
sg_copy_results
23.3
KB
-rwxr-xr-x
sg_dd
54.33
KB
-rwxr-xr-x
sg_decode_sense
14.76
KB
-rwxr-xr-x
sg_emc_trespass
14.3
KB
-rwxr-xr-x
sg_format
39.35
KB
-rwxr-xr-x
sg_get_config
35.38
KB
-rwxr-xr-x
sg_get_elem_status
26.79
KB
-rwxr-xr-x
sg_get_lba_status
22.95
KB
-rwxr-xr-x
sg_ident
14.6
KB
-rwxr-xr-x
sg_inq
115.61
KB
-rwxr-xr-x
sg_logs
146.93
KB
-rwxr-xr-x
sg_luns
22.79
KB
-rwxr-xr-x
sg_map
18.3
KB
-rwxr-xr-x
sg_map26
26.7
KB
-rwxr-xr-x
sg_modes
46.08
KB
-rwxr-xr-x
sg_opcodes
35.01
KB
-rwxr-xr-x
sg_persist
36.08
KB
-rwxr-xr-x
sg_prevent
14.51
KB
-rwxr-xr-x
sg_raw
26.91
KB
-rwxr-xr-x
sg_rbuf
22.73
KB
-rwxr-xr-x
sg_rdac
18.3
KB
-rwxr-xr-x
sg_read
26.31
KB
-rwxr-xr-x
sg_read_attr
36.65
KB
-rwxr-xr-x
sg_read_block_limits
14.54
KB
-rwxr-xr-x
sg_read_buffer
27.56
KB
-rwxr-xr-x
sg_read_long
14.7
KB
-rwxr-xr-x
sg_readcap
22.79
KB
-rwxr-xr-x
sg_reassign
18.66
KB
-rwxr-xr-x
sg_referrals
14.66
KB
-rwxr-xr-x
sg_rep_pip
14.57
KB
-rwxr-xr-x
sg_rep_zones
26.8
KB
-rwxr-xr-x
sg_requests
22.76
KB
-rwxr-xr-x
sg_reset
14.66
KB
-rwxr-xr-x
sg_reset_wp
14.6
KB
-rwxr-xr-x
sg_rmsn
14.51
KB
-rwxr-xr-x
sg_rtpg
14.6
KB
-rwxr-xr-x
sg_safte
22.7
KB
-rwxr-xr-x
sg_sanitize
27.01
KB
-rwxr-xr-x
sg_sat_identify
18.73
KB
-rwxr-xr-x
sg_sat_phy_event
19.01
KB
-rwxr-xr-x
sg_sat_read_gplog
18.73
KB
-rwxr-xr-x
sg_sat_set_features
18.7
KB
-rwxr-xr-x
sg_scan
18.38
KB
-rwxr-xr-x
sg_seek
18.88
KB
-rwxr-xr-x
sg_senddiag
27.2
KB
-rwxr-xr-x
sg_ses
119.97
KB
-rwxr-xr-x
sg_ses_microcode
27.36
KB
-rwxr-xr-x
sg_start
18.85
KB
-rwxr-xr-x
sg_stpg
22.73
KB
-rwxr-xr-x
sg_stream_ctl
18.7
KB
-rwxr-xr-x
sg_sync
14.66
KB
-rwxr-xr-x
sg_test_rwbuf
18.6
KB
-rwxr-xr-x
sg_timestamp
22.83
KB
-rwxr-xr-x
sg_turs
26.7
KB
-rwxr-xr-x
sg_unmap
22.76
KB
-rwxr-xr-x
sg_verify
22.91
KB
-rwxr-xr-x
sg_vpd
118.42
KB
-rwxr-xr-x
sg_wr_mode
22.73
KB
-rwxr-xr-x
sg_write_buffer
27.23
KB
-rwxr-xr-x
sg_write_long
14.76
KB
-rwxr-xr-x
sg_write_same
26.95
KB
-rwxr-xr-x
sg_write_verify
26.79
KB
-rwxr-xr-x
sg_write_x
55.6
KB
-rwxr-xr-x
sg_xcopy
42.32
KB
-rwxr-xr-x
sg_zone
14.86
KB
-rwxr-xr-x
sginfo
76.01
KB
-rwxr-xr-x
sgm_dd
34.31
KB
-rwxr-xr-x
sgp_dd
46.31
KB
-rwxr-xr-x
sh
126.74
KB
-rwxr-xr-x
sha1sum
38.41
KB
-rwxr-xr-x
sha224sum
38.41
KB
-rwxr-xr-x
sha256sum
38.41
KB
-rwxr-xr-x
sha384sum
38.41
KB
-rwxr-xr-x
sha512sum
38.41
KB
-rwxr-xr-x
shasum
9.75
KB
-rwxr-xr-x
showconsolefont
18.37
KB
-rwxr-xr-x
showkey
18.37
KB
-rwxr-xr-x
shred
54.51
KB
-rwxr-xr-x
shuf
46.51
KB
-rwxr-xr-x
sigtool
6.74
MB
-rwxr-xr-x
skill
26.41
KB
-rwxr-xr-x
slabtop
22.44
KB
-rwxr-xr-x
sleep
34.51
KB
-rwxr-xr-x
slogin
827.04
KB
-rwxr-xr-x
snap
20.64
MB
-rwxr-xr-x
snapctl
7.29
MB
-rwxr-xr-x
snapfuse
38.23
KB
-rwxr-xr-x
snice
26.41
KB
-rwxr-xr-x
socat
447.68
KB
-rwxr-xr-x
socat-broker.sh
2.24
KB
-rwxr-xr-x
socat-chain.sh
7.86
KB
-rwxr-xr-x
socat-mux.sh
3.47
KB
-rwxr-xr-x
socat1
447.68
KB
-rwxr-xr-x
soelim
34.48
KB
-rwxr-xr-x
sort
102.8
KB
-rwxr-xr-x
sos
612
B
-rwxr-xr-x
sos-collector
1.04
KB
-rwxr-xr-x
sosreport
1.03
KB
-rwxr-xr-x
sotruss
4.21
KB
-rwxr-xr-x
speedtest
980
B
-rwxr-xr-x
speedtest-cli
988
B
-rwxr-xr-x
splain
18.99
KB
-rwxr-xr-x
split
54.94
KB
-rwxr-xr-x
splitfont
14.3
KB
-rwxr-xr-x
sprof
34.44
KB
-rwxr-xr-x
sqfscat
147.9
KB
-rwxr-xr-x
sqfstar
286.95
KB
-rwxr-xr-x
ss
129.07
KB
-rwxr-xr-x
ssh
827.04
KB
-rwxr-xr-x
ssh-add
294.42
KB
-rwxr-xr-x
ssh-agent
302.43
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
12.77
KB
-rwxr-xr-x
ssh-import-id
985
B
-rwxr-xr-x
ssh-import-id-gh
785
B
-rwxr-xr-x
ssh-import-id-lp
785
B
-rwxr-xr-x
ssh-keygen
442.44
KB
-rwxr-xr-x
ssh-keyscan
330.44
KB
-rwxr-xr-x
stat
86.52
KB
-rwxr-xr-x
static-sh
2.03
MB
-rwxr-xr-x
stdbuf
50.51
KB
-rwxr-xr-x
strace
1.99
MB
-rwxr-xr-x
strace-log-merge
1.78
KB
-rwxr-xr-x
streamzip
7.87
KB
-rwxr-xr-x
stty
78.52
KB
-rwxr-xr-x
su
54.38
KB
-rwsr-xr-x
sudo
271.42
KB
-rwsr-xr-x
sudoedit
271.42
KB
-rwsr-xr-x
sudoreplay
95.95
KB
-rwxr-xr-x
sum
34.41
KB
-rwxr-xr-x
sync
34.41
KB
-rwxr-xr-x
systemctl
1.43
MB
-rwxr-xr-x
systemd
98.45
KB
-rwxr-xr-x
systemd-ac-power
14.45
KB
-rwxr-xr-x
systemd-analyze
198.85
KB
-rwxr-xr-x
systemd-ask-password
18.58
KB
-rwxr-xr-x
systemd-cat
18.45
KB
-rwxr-xr-x
systemd-cgls
22.57
KB
-rwxr-xr-x
systemd-cgtop
38.47
KB
-rwxr-xr-x
systemd-confext
54.64
KB
-rwxr-xr-x
systemd-creds
42.72
KB
-rwxr-xr-x
systemd-cryptenroll
70.92
KB
-rwxr-xr-x
systemd-cryptsetup
78.95
KB
-rwxr-xr-x
systemd-delta
26.45
KB
-rwxr-xr-x
systemd-detect-virt
18.45
KB
-rwxr-xr-x
systemd-escape
22.45
KB
-rwxr-xr-x
systemd-firstboot
58.82
KB
-rwxr-xr-x
systemd-hwdb
154.74
KB
-rwxr-xr-x
systemd-id128
22.45
KB
-rwxr-xr-x
systemd-inhibit
22.47
KB
-rwxr-xr-x
systemd-machine-id-setup
18.63
KB
-rwxr-xr-x
systemd-mount
50.78
KB
-rwxr-xr-x
systemd-notify
26.66
KB
-rwxr-xr-x
systemd-path
18.45
KB
-rwxr-xr-x
systemd-repart
195.23
KB
-rwxr-xr-x
systemd-run
66.79
KB
-rwxr-xr-x
systemd-socket-activate
30.45
KB
-rwxr-xr-x
systemd-stdio-bridge
22.45
KB
-rwxr-xr-x
systemd-sysext
54.64
KB
-rwxr-xr-x
systemd-sysusers
66.63
KB
-rwxr-xr-x
systemd-tmpfiles
114.7
KB
-rwxr-xr-x
systemd-tty-ask-password-agent
34.45
KB
-rwxr-xr-x
systemd-umount
50.78
KB
-rwxr-xr-x
tabs
18.3
KB
-rwxr-xr-x
tac
38.41
KB
-rwxr-xr-x
tail
62.53
KB
-rwxr-xr-x
tapestat
26.44
KB
-rwxr-xr-x
tar
421.92
KB
-rwxr-xr-x
taskset
30.38
KB
-rwxr-xr-x
tbl
134.48
KB
-rwxr-xr-x
tclsh
14.15
KB
-rwxr-xr-x
tclsh8.6
14.15
KB
-rwxr-xr-x
tcpdump
1.21
MB
-rwxr-xr-x
tee
38.51
KB
-rwxr-xr-x
telnet
177.85
KB
-rwxr-xr-x
tempfile
14.3
KB
-rwxr-xr-x
test
46.44
KB
-rwxr-xr-x
tic
90.41
KB
-rwxr-xr-x
time
26.52
KB
-rwxr-xr-x
timedatectl
46.45
KB
-rwxr-xr-x
timeout
38.95
KB
-rwxr-xr-x
tkconch3
227
B
-rwxr-xr-x
tload
22.39
KB
-rwxr-xr-x
tmux
1.05
MB
-rwxr-xr-x
tnftp
182.9
KB
-rwxr-xr-x
toe
22.3
KB
-rwxr-xr-x
top
131.7
KB
-rwxr-xr-x
touch
94.51
KB
-rwxr-xr-x
tput
26.34
KB
-rwxr-xr-x
tr
46.51
KB
-rwxr-xr-x
trace-cmd
435.41
KB
-rwxr-xr-x
tracepath
18.15
KB
-rwxr-xr-x
trial3
219
B
-rwxr-xr-x
troff
726.62
KB
-rwxr-xr-x
true
26.3
KB
-rwxr-xr-x
truncate
38.51
KB
-rwxr-xr-x
tset
26.31
KB
-rwxr-xr-x
tsort
46.51
KB
-rwxr-xr-x
tty
34.51
KB
-rwxr-xr-x
turbostat
1.58
KB
-rwxr-xr-x
twist3
239
B
-rwxr-xr-x
twistd3
220
B
-rwxr-xr-x
tzselect
15.02
KB
-rwxr-xr-x
ua
1003
B
-rwxr-xr-x
ubuntu-advantage
1003
B
-rwxr-xr-x
ubuntu-bug
2.27
KB
-rwxr-xr-x
ubuntu-distro-info
26.89
KB
-rwxr-xr-x
ubuntu-security-status
22.25
KB
-rwxr-xr-x
ucf
40.68
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.85
KB
-rwxr-xr-x
uclampset
30.38
KB
-rwxr-xr-x
udevadm
1.37
MB
-rwxr-xr-x
udisksctl
62.38
KB
-rwxr-xr-x
ul
22.38
KB
-rwxr-xr-x
umount
38.38
KB
-rwsr-xr-x
uname
34.51
KB
-rwxr-xr-x
unattended-upgrade
97.21
KB
-rwxr-xr-x
unattended-upgrades
97.21
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
38.53
KB
-rwxr-xr-x
unicode_start
2.71
KB
-rwxr-xr-x
unicode_stop
528
B
-rwxr-xr-x
uniq
38.51
KB
-rwxr-xr-x
unlink
34.51
KB
-rwxr-xr-x
unlzma
86.92
KB
-rwxr-xr-x
unmkinitramfs
3.7
KB
-rwxr-xr-x
unshare
42.6
KB
-rwxr-xr-x
unsquashfs
147.9
KB
-rwxr-xr-x
unxz
86.92
KB
-rwxr-xr-x
unzip
174.42
KB
-rwxr-xr-x
unzipsfx
74.42
KB
-rwxr-xr-x
unzstd
998.79
KB
-rwxr-xr-x
update-alternatives
58.38
KB
-rwxr-xr-x
update-mime-database
74.33
KB
-rwxr-xr-x
uptime
14.38
KB
-rwxr-xr-x
usb-devices
4.83
KB
-rwxr-xr-x
usbhid-dump
30.38
KB
-rwxr-xr-x
usbip
1.58
KB
-rwxr-xr-x
usbipd
1.58
KB
-rwxr-xr-x
usbreset
14.3
KB
-rwxr-xr-x
users
34.51
KB
-rwxr-xr-x
utmpdump
22.38
KB
-rwxr-xr-x
uuidgen
18.38
KB
-rwxr-xr-x
uuidparse
22.38
KB
-rwxr-xr-x
varlinkctl
30.45
KB
-rwxr-xr-x
vcs-run
6.75
KB
-rwxr-xr-x
vdir
138.98
KB
-rwxr-xr-x
vi
3.94
MB
-rwxr-xr-x
view
3.94
MB
-rwxr-xr-x
vigpg
2.58
KB
-rwxr-xr-x
vim
3.94
MB
-rwxr-xr-x
vim.basic
3.94
MB
-rwxr-xr-x
vim.tiny
1.66
MB
-rwxr-xr-x
vimdiff
3.94
MB
-rwxr-xr-x
vimtutor
2.1
KB
-rwxr-xr-x
vm-support
9.83
KB
-rwxr-xr-x
vmhgfs-fuse
46.73
KB
-rwxr-xr-x
vmstat
38.78
KB
-rwxr-xr-x
vmtoolsd
74.56
KB
-rwxr-xr-x
vmware-alias-import
42.52
KB
-rwxr-xr-x
vmware-checkvm
14.38
KB
-rwxr-xr-x
vmware-hgfsclient
14.38
KB
-rwxr-xr-x
vmware-namespace-cmd
22.3
KB
-rwxr-xr-x
vmware-rpctool
18.3
KB
-rwxr-xr-x
vmware-toolbox-cmd
54.59
KB
-rwxr-xr-x
vmware-vgauth-cmd
18.3
KB
-rwxr-xr-x
vmware-vmblock-fuse
22.78
KB
-rwxr-xr-x
vmware-xferlogs
32.33
KB
-rwxr-xr-x
vnstat
149.36
KB
-rwxr-xr-x
vsftpdwho
54
B
-rwxr-xr-x
w
26.38
KB
-rwxr-xr-x
w3m
1.58
MB
-rwxr-xr-x
w3mman
1.37
KB
-rwxr-xr-x
wall
22.38
KB
-rwxr-xr-x
watch
30.84
KB
-rwxr-xr-x
watchgnupg
22.3
KB
-rwxr-xr-x
wc
54.52
KB
-rwxr-xr-x
wdctl
34.4
KB
-rwxr-xr-x
wget
459.02
KB
-rwxr-xr-x
whatis
47.28
KB
-rwxr-xr-x
whereis
30.84
KB
-rwxr-xr-x
which
1.05
KB
-rwxr-xr-x
which.debianutils
1.05
KB
-rwxr-xr-x
whiptail
30.16
KB
-rwxr-xr-x
who
58.52
KB
-rwxr-xr-x
whoami
34.51
KB
-rwxr-xr-x
whois
155.66
KB
-rwxr-xr-x
wifi-status
2.06
KB
-rwxr-xr-x
write
22.38
KB
-rwxr-xr-x
wrk
78.87
KB
-rwxr-xr-x
wsrep_sst_backup
2.39
KB
-rwxr-xr-x
wsrep_sst_common
66.86
KB
-rwxr-xr-x
wsrep_sst_mariabackup
49.23
KB
-rwxr-xr-x
wsrep_sst_mysqldump
8.11
KB
-rwxr-xr-x
wsrep_sst_rsync
29.72
KB
-rwxr-xr-x
wsrep_sst_rsync_wan
29.72
KB
-rwxr-xr-x
www-browser
1.58
MB
-rwxr-xr-x
x86_64
26.65
KB
-rwxr-xr-x
x86_energy_perf_policy
1.58
KB
-rwxr-xr-x
xargs
62.41
KB
-rwxr-xr-x
xauth
54.96
KB
-rwxr-xr-x
xdg-user-dir
234
B
-rwxr-xr-x
xdg-user-dirs-update
26.23
KB
-rwxr-xr-x
xsubpp
5.05
KB
-rwxr-xr-x
xxd
22.28
KB
-rwxr-xr-x
xz
86.92
KB
-rwxr-xr-x
xzcat
86.92
KB
-rwxr-xr-x
xzcmp
7.25
KB
-rwxr-xr-x
xzdiff
7.25
KB
-rwxr-xr-x
xzegrep
10.09
KB
-rwxr-xr-x
xzfgrep
10.09
KB
-rwxr-xr-x
xzgrep
10.09
KB
-rwxr-xr-x
xzless
1.77
KB
-rwxr-xr-x
xzmore
2.14
KB
-rwxr-xr-x
yes
34.38
KB
-rwxr-xr-x
ypdomainname
22.23
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
6.31
KB
-rwxr-xr-x
zdump
30.28
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
206.98
KB
-rwxr-xr-x
zipcloak
70.4
KB
-rwxr-xr-x
zipdetails
68.55
KB
-rwxr-xr-x
zipgrep
2.89
KB
-rwxr-xr-x
zipinfo
174.42
KB
-rwxr-xr-x
zipnote
62.4
KB
-rwxr-xr-x
zipsplit
58.4
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
zstd
998.79
KB
-rwxr-xr-x
zstdcat
998.79
KB
-rwxr-xr-x
zstdgrep
3.78
KB
-rwxr-xr-x
zstdless
197
B
-rwxr-xr-x
zstdmt
998.79
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : ucf
#!/bin/sh # -*- Mode: Sh -*- # updateConfFile.sh --- # Author : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) # Created On : Fri Feb 1 03:41:47 2002 # Created On Node : glaurung.green-gryphon.com # Last Modified By : Manoj Srivastava # Last Modified On : Tue Jun 6 09:48:22 2006 # Last Machine Used: glaurung.internal.golden-gryphon.com # Update Count : 186 # Status : Unknown, Use with caution! # HISTORY : # Description : # # This script attempts to provide conffile like handling for files not # shipped in a Debian package, but handled by the postinst. Using this # script, one may ship a bunch of default cofiguration files somewhere # in /usr (/usr/share/<pkg> is a good location), and maintain files in # /etc. # # The motivation for this script was to provide conffile like handling # for start files for emacs lisp packages (for example, # /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not # shipped with the package, instead, they are installed during the # post installation configuration phase by the script # /usr/lib/emacsen-common/emacs-package-install $package_name. # # This script is meant to be invoked by the packages install script at # /usr/lib/emacsen-common/packages/install/$package_name for each # flavour of installed emacsen by calling it with the proper values of # new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file # (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest. # # make sure we exit on error set -e # set the version and revision progname="$(basename $0)" pversion='Revision: 3.00 ' unset GREP_OPTIONS ###################################################################### ######## ######### ######## Utility functions ######### ######## ######### ###################################################################### setq() { # Variable Value Doc_string if [ "x$2" = "x" ]; then echo >&2 "$progname: Unable to determine $3" exit 1; else if [ "x$VERBOSE" != "x" ]; then echo >&2 "$progname: $3 is $2"; fi eval "$1=\"\$2\""; fi } # Usage: get_file_metadate file_name get_file_metadata() { if [ -e "$1" ]; then # get file modification date without the nanoseconds and timezone info local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))" # print file_name user.group permissions above_date stat --format "%n %U.%G 0%a $moddate" "$1" else echo "/dev/null" fi } # Runs the diff command with approrpiate arguments # Usage run_diff diff|sdiff diff_opts old_file new_file run_diff() { local diff_cmd="$1" local diff_opt="$2" local old_file="$3" local new_file="$4" # Note: get_file_metadata not in quotes to ignore "\n" characters local old_file_label="$(get_file_metadata "$old_file")" local new_file_label="$(get_file_metadata "$new_file")" [ -e "$old_file" ] || old_file=/dev/null [ -e "$new_file" ] || new_file=/dev/null if [ "$diff_cmd" = "diff" ] ; then diff "$diff_opt" --label "$old_file_label" "$old_file" \ --label "$new_file_label" "$new_file" || true elif [ "$diff_cmd" = "sdiff" ] ; then # unfortunatelly the sdiff command does not support --label option local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \ "$old_file_label" "$new_file_label" "$out" else echo "Unknown diff command: $diff_cmd" >&2 exit 1 fi } # Use debconf to show the differences # Usage: show_diff actual_file_differences file_stat_differences show_diff() { if [ -z "$1" ]; then DIFF="There are no non-white space differences in the files." else if [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then DIFF="The differences between the files are too large to display." else DIFF="$1" fi fi if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then templ=ucf/show_diff db_capb escape db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)" db_fset $templ seen false db_input critical $templ || true db_go || true db_get $templ # may contain sensitive information, so clear # immediatly after use so it is never written # to disk db_subst $templ DIFF "" db_reset $templ db_capb else if [ -z "$my_pager" ]; then echo "$DIFF" | sensible-pager else echo "$DIFF" | $my_pager fi fi } withecho () { echo "$@" >&2 "$@" } usageversion () { cat >&2 <<END Debian GNU/Linux $progname $pversion. Copyright (C) 2002-2005 Manoj Srivastava. This is free software; see the GNU General Public Licence for copying conditions. There is NO warranty. Usage: $progname [options] new_file destination Options: -h, --help print this message -s foo, --src-dir foo Set the src dir (historical md5sums live here) --sum-file bar Force the historical md5sums to be read from this file. Overrides any setting of --src-dir. -d[n], --debug=[n] Set the Debug level to N. Please note there must be no spaces before the debug level -n, --no-action Dry run. No action is actually taken. -P foo, --package foo Don't follow dpkg-divert diversions by package foo. -v, --verbose Make the script verbose --three-way Register this file in the cache, and turn on the diff3 option allowing the merging of maintainer changes into a (potentially modified) local configuration file. ) --state-dir bar Set the state directory to bar instead of the default '/var/lib/ucf'. Used mostly for testing. --debconf-ok Indicate that it is ok for ucf to use an already running debconf instance for prompting. --debconf-template bar Specify an alternate, caller-provided debconf template to use for prompting. Usage: $progname -p destination -p, --purge Remove any reference to destination from records By default, the directory the new_file lives in is assumed to be the src-dir, which is where we look for any historical md5sums. END } ###################################################################### ######## ######### ######## file and hash save/restore functions ######### ######## ######### ###################################################################### purge_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 \ || true; fi #echo "grep -Ev [[:space:]]${safe_dest_file}$ $statedir/hashfile" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; if [ "X$docmd" = "XYES" ]; then mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" else echo mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" fi set -e fi fi test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file" if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then $action rm -f "$statedir/cache/$cached_file" fi } replace_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";" grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2; fi grep -Ev "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \ "$statedir/hashfile.tmp"; mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" set -e else echo "(grep -Ev \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\"" echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; " echo ") | sort > \"$statedir/hashfile\"" fi else if [ "X$docmd" = "XYES" ]; then md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" > \ "$statedir/hashfile" else echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \ "\"$statedir/hashfile\"" fi fi file_size=$(stat -c '%s' "$orig_new_file") if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then $action cp -pf "$orig_new_file" "$statedir/cache/$cached_file" fi # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" } replace_conf_file () { # do not mangle $dest_file since it's the one registered in the hashfile # or we have been ask to register real_file="$dest_file" if [ -L "$dest_file" ]; then real_file="$(readlink -nf $dest_file || :)" if [ "x$real_file" = "x" ]; then echo >&2 "$dest_file is a broken symlink!" $action rm -f "$dest_file"; real_file="$dest_file" fi fi if [ -e "$real_file" ]; then if [ -z "$RETAIN_OLD" ]; then #echo "Saving ${real_file}.${OLD_SUFFIX}, in case." if [ "x$VERBOSE" != "x" ]; then echo >&2 "Not saving ${real_file}, since it was unmodified" fi else $action cp -pf $selinux "${real_file}" "${real_file}.${OLD_SUFFIX}" fi fi if [ -e "${real_file}" ]; then # Do not change the permissions and attributes of the destination $action cp -f $selinux "$new_file" "${real_file}" else # No destination file exists $action cp -pf $selinux "$new_file" "${real_file}" fi replace_md5sum; } # Escape single quotes in the arguments passed in quote_single() { printf "%s\n" "$1" | sed -e "s,','\\\\'',g" } ###################################################################### ######## ######### ######## Command line args ######### ######## ######### ###################################################################### # # Long term variables# # docmd='YES' action='withecho' action= selinux='' DEBUG=0 VERBOSE='' statedir='/var/lib/ucf'; THREEWAY= DIST_SUFFIX="ucf-dist" NEW_SUFFIX="ucf-new" OLD_SUFFIX="ucf-old" ERR_SUFFIX="merge-error" # save up the cmdline with proper quoting/escaping for arg in "$@"; do saved="${saved:+$saved }'$(quote_single "$arg")'" done # Note that we use `"$@"' to let each command-line parameter expand to a # separate word. The quotes around `$@' are essential! # We need TEMP as the `eval set --' would nuke the return value of getopt. TEMP=$(getopt -a -o hs:d::D::npP:Zv -n "$progname" \ --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,package:,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \ -- "$@") # Note the quotes around `$TEMP': they are essential! eval set -- "$TEMP" while true ; do case "$1" in -h|--help) usageversion; exit 0 ;; -n|--no-action) action='echo'; docmd='NO'; shift ;; -v|--verbose) VERBOSE=1; shift ;; -P|--package) opt_package="$2"; shift 2 ;; -s|--src-dir) opt_source_dir="$2"; shift 2 ;; --sum-file) opt_old_mdsum_file="$2"; shift 2 ;; --state-dir) opt_state_dir="$2"; shift 2 ;; --debconf-template) override_template="$2"; shift 2 ;; -D|-d|--debug|--DEBUG) # d has an optional argument. As we are in quoted mode, # an empty parameter will be generated if its optional # argument is not found. case "$2" in "") setq DEBUG 1 "The Debug value"; shift 2 ;; *) setq DEBUG "$2" "The Debug value"; shift 2 ;; esac ;; -p|--purge) PURGE=YES; shift ;; --three-way) THREEWAY=YES; shift ;; --debconf-ok) DEBCONF_OK=YES; shift ;; -Z) selinux='-Z'; shift ;; --) shift ; break ;; *) echo >&2 "Internal error!" ; exit 1 ;; esac done ###################################################################### ######## ######### ######## Sanity checking ######### ######## ######### ###################################################################### # Need to run as root, or else the if test "$(id -u)" != 0; then if [ "$docmd" = "YES" ]; then echo "$progname: Need to be run as root." >&2 echo "$progname: Setting up no action mode." >&2 action='echo'; docmd='NO'; fi fi if [ "X$PURGE" = "XYES" ]; then if [ $# != 1 ]; then echo >&2 "*** ERROR: Need exactly one argument when purging, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_dest_file="$1"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi else if [ $# != 2 ]; then echo >&2 "*** ERROR: Need exactly two arguments, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_new_file="$1"; temp_dest_file="$2"; if [ ! -e "${temp_new_file}" ]; then echo >&2 "Error: The new file ${temp_new_file} does not exist!"; exit 1; fi setq new_file "$(readlink -q -m $temp_new_file)" "The new file"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi fi # Follow dpkg-divert as though we are installed as part of $opt_package divert_line=$(dpkg-divert --listpackage "$dest_file") if [ -n "$divert_line" ]; then # name of the package or 'LOCAL' for a local diversion divert_package="$divert_line" if [ "$divert_package" != "$opt_package" ]; then dest_file=$(dpkg-divert --truename "$dest_file") fi fi safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"') ###################################################################### ######## ######### ######## Set Default Values ######### ######## ######### ###################################################################### # Load site defaults and over rides. if [ -f /etc/ucf.conf ]; then . /etc/ucf.conf fi # Command line, env variable, config file, or default if [ ! "x$opt_source_dir" = "x" ]; then setq source_dir "$opt_source_dir" "The Source directory" elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then setq source_dir "$UCF_SOURCE_DIR" "The Source directory" elif [ ! "x$conf_source_dir" = "x" ]; then setq source_dir "$conf_source_dir" "The Source directory" else if [ "X$new_file" != "X" ]; then setq source_dir "$(dirname $new_file)" "The Source directory" else setq source_dir "/tmp" "The Source directory" fi fi if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then my_pager="$(which $PAGER)"; elif [ -s /usr/bin/pager ] && [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then my_pager=/usr/bin/pager elif [ -x /usr/bin/sensible-pager ]; then my_pager=/usr/bin/sensible-pager elif [ -x /bin/more ]; then my_pager=/bin/more else my_pager= fi # Command line, env variable, config file, or default if [ ! "x$opt_state_dir" = "x" ]; then setq statedir "$opt_state_dir" "The State directory" elif [ ! "x$UCF_STATE_DIR" = "x" ]; then setq statedir "$UCF_STATE_DIR" "The State directory" elif [ ! "x$conf_state_dir" = "x" ]; then setq statedir "$conf_state_dir" "The State directory" else setq statedir '/var/lib/ucf' "The State directory" fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffold" = "x" ]; then setq force_conffold "$opt_force_conffold" "Keep the old file" elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file" elif [ ! "x$conf_force_conffold" = "x" ]; then setq force_conffold "$conf_force_conffold" "Keep the old file" else force_conffold='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffnew" = "x" ]; then setq force_conffnew "$opt_force_conffnew" "Replace the old file" elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file" elif [ ! "x$conf_force_conffnew" = "x" ]; then setq force_conffnew "$conf_force_conffnew" "Replace the old file" else force_conffnew='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffmiss" = "x" ]; then setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files" elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files" elif [ ! "x$conf_force_conffmiss" = "x" ]; then setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files" else force_conffmiss='' fi if [ -n "$opt_old_mdsum_file" ]; then setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here" elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here" elif [ ! "x$conf_old_mdsum_file" = "x" ]; then setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file" elif [ ! "x${new_file}" = "x" ]; then old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum"; else old_mdsum_file=""; fi ###################################################################### ######## ######### ######## More Sanity checking ######### ######## ######### ###################################################################### if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then echo >&2 "Error: Only one of force_conffold and force_conffnew should"; echo >&2 " be set"; exit 1; fi # VERBOSE of 0 is supposed to be the same as not setting VERBOSE if [ "X$VERBOSE" = "X0" ]; then VERBOSE='' fi # if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then echo >&2 "ucf: do not have write privilege to the state data" if [ "X$docmd" = "XYES" ]; then exit 1; fi fi if [ ! -d $statedir/cache ]; then $action mkdir -p $statedir/cache ; fi # test and see if this file exists in the database if [ -e "$statedir/hashfile" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "The hash file exists" echo >&2 "grep -E" "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true fi lastsum=$(grep -E "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \ awk '{print $1;}' ) fi if [ ! "x${new_file}" = "x" ]; then old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d"; else old_mdsum_dir=""; fi cached_file="$(echo $dest_file | tr / :)" ###################################################################### ######## ######### ######## Debugging dump ######### ######## ######### ###################################################################### if [ $DEBUG -gt 0 ]; then cat >&2 <<EOF The new start file is \`$new_file\' The destination is \`$dest_file\' (\`$safe_dest_file\') The history is kept under \'$source_dir\' The file may be cached at \'$statedir/cache/$cached_file\' EOF if [ -s "$dest_file" ]; then echo "The destination file exists, and has md5sum:" md5sum "$dest_file" else echo "The destination file does not exist." fi if [ "X$lastsum" != "X" ]; then echo "The old md5sum exists, and is:" echo "$lastsum" else echo "The old md5sum does not exist." if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then echo "However, there are historical md5sums around." fi fi if [ -e "$new_file" ]; then echo "The new file exists, and has md5sum:" md5sum "$new_file" else echo "The new file does not exist." fi if [ -d "$old_mdsum_dir" ]; then echo "The historical md5sum dir $old_mdsum_dir exists" elif [ -f "$old_mdsum_file" ]; then echo "The historical md5sum file $old_mdsum_file exists" else echo "Historical md5sums are not available" fi fi ###################################################################### ######## ######### ######## Short circuit if we are purging ######### ######## ######### ###################################################################### if [ "X$PURGE" = "XYES" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "Preparing to purge ${dest_file}" fi purge_md5sum; exit 0; fi # now we can restore $@ eval set -- "$saved" ###################################################################### ######## ######### ######## DebConf stuff ######### ######## ######### ###################################################################### # Is debconf already running? Kinda tricky, because it will be after the # confmodule is sourced, so only test before that. if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then if [ "$DEBIAN_HAS_FRONTEND" ]; then DEBCONF_ALREADY_RUNNING='YES' else DEBCONF_ALREADY_RUNNING='NO' fi fi export DEBCONF_ALREADY_RUNNING if [ -z "$DEBCONF_OK" ]; then if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then DEBCONF_OK='NO' else DEBCONF_OK='YES' fi fi # Time to start nagging the users who call ucf without debconf-ok if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then # Commented out for now, uncomment after a while to begin nagging # maintainers to fix their scripts. cat \ <<END *** WARNING: ucf was run from a maintainer script that uses debconf, but the script did not pass --debconf-ok to ucf. The maintainer script should be fixed to not stop debconf before calling ucf, and pass it this parameter. For now, ucf will revert to using old-style, non-debconf prompting. Ugh! Please inform the package maintainer about this problem. END fi # Start up debconf or at least get the db_* commands available if [ -e /usr/share/debconf/confmodule ]; then if test "$(id -u)" = 0; then . /usr/share/debconf/confmodule # Load our templates, just in case our template has # not been loaded or the Debconf DB lost or corrupted # since then, but only if it is OK to use debconf. if [ "$DEBCONF_OK" = 'YES' ]; then db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf fi else echo >&2 "$progname: Not loading confmodule, since we are not running as root." fi # Only set the title if debconf was not already running. # If it was running, then we do not want to clobber the # title used for configuring the whole package with debconf. if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then if ! db_settitle ucf/title 2>/dev/null; then # Older debconf that does not support that command. if test "$(id -u)" = 0; then db_title "Modified configuration file" else echo >&2 "$progname: Not changing title, since we are not running as root." fi fi fi fi ###################################################################### ######## ######### ######## Start Processing ######### ######## ######### ###################################################################### orig_new_file="$new_file" # Since sometimes we replace the newfile below newsum=$(md5sum "$new_file" | awk '{print $1}') # Determine the action for the current file. The default is to ask, # with non-replacement being the norm. # If the config dir exists # if file in always overwrite, state +=1; # fi # if file in never overwrite, state +=2; # fi # if file in ask; state +=4 # fi # if state == 0; then state = default # if state >= 4; ask # if state == 3; ask # if state == 2; exit # if state == 1; then replace_conffile; exit ###################################################################### ######## ######### ######## Do the replacement ######### ######## ######### ###################################################################### # Step 1: If we have no record of this file, and dest file # does, We need to determine how to initialize the # ${old_mdsum_prefix}.old file.. if [ -e "$dest_file" ]; then destsum=$(md5sum "$dest_file" | awk '{print $1}'); if [ "X$lastsum" = "X" ]; then # a: If we have a directory containing historical md5sums of this # file in question, we should look and see if the currently # installed file matches any of the old md5sums; in which case # it can be silently replaced. if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then if [ -d "$old_mdsum_dir" ]; then for file in ${old_mdsum_dir}/*; do oldsum="$(awk '{print $1}' $file)"; if [ "$oldsum" = "$destsum" ]; then if [ "X$force_conffold" = "X" ]; then # Bingo! replace, set the md5sum, and we are done if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi done elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "^${destsum}" "$old_mdsum_file" || true) if [ "X$oldsum" != "X" ]; then # Bingo if [ "X$force_conffold" = "X" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi fi # Well, nothing matched. We now check to see if the # maintainer has an opinion on how to set the ``md5sum of the # previously installed version'', since we have no way of # determining that automatically. Please note that unless # there are limited number of previously released packages # (like just one), the maintainer is also making a guess at # this point by supplying a historical md5sum default file. if [ "X$VERBOSE" != "X" ]; then echo >&2 "Historical md5sums did not match." fi if [ -d "$old_mdsum_dir" ]; then if [ -e "${old_mdsum_dir}/default" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "However, a default entry exists, using it." fi lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)" do_replace_md5sum=1; fi elif [ -f "$old_mdsum_file" ]; then oldsum=$(grep -E "[[:space:]]default$" "$old_mdsum_file" | \ awk '{print $1;}') if [ "X$oldsum" != "X" ]; then # Bingo lastsum=$oldsum; do_replace_md5sum=1; fi fi fi # At this point, we are almost certain that either the # historical record of md5sums is not complete, or the user has # changed the configuration file. Rather than guessing and # chosing one of the historical md5sums, we fall through to the # solution used if there had been no historical md5sums # directory/file. if [ "X$lastsum" = "X" ]; then # b: We do not have a historical list of md5sums, or none # matched, and we still need to initialize the # ${old_mdsum_prefix}.old file. We can't determine whther or # not they made any changes, so we err on the side of caution # and ask' if [ "X$VERBOSE" != "X" ]; then echo >&2 "No match found, we shall ask." fi lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; fi # the old md5sum file does not exist, and the historical # record failed fi # the old md5sum file does not exist (bug)) else # "$dest_file" does not exist # Step 2: If destfile does not exist, create it, set the file # "${old_mdsum_prefix}.old" to the md5sum of the new file, and we # are done if [ "X$lastsum" = "X" ]; then # Ok, so there is no indication that the package was ever # installed on this machine. echo >&2 "" echo >&2 "Creating config file $dest_file with new version" replace_conf_file; exit 0; elif [ "$lastsum" = "$newsum" ]; then # OK, new version of the file is the same as the last version # we saw. Since the user apparently has deleted the file, # nothing needs be done, unless we have been told differently if [ "X$force_conffmiss" != "X" ]; then echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else echo >&2 "Not replacing deleted config file $dest_file"; fi else # OK. New upstream version. if [ "X$force_conffmiss" != "X" ]; then # User has said to replace missing files, so we do so, no # questions asked. echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else # Even though the user has deleted this file, they should # be asked now, unless specified otherwise. if [ "X$force_conffold" = "X" ]; then destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; else exit 0; fi fi fi fi # Here, the destfile exists. # step 3: If the old md5sum and the md5sum of the new file # do not match, we need to take action. if [ "$lastsum" = "$newsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums match, nothing needs be done." fi if [ "X$do_replace_md5sum" != "X" ]; then replace_md5sum; fi exit 0; # Hah. Match. We are done. fi # a: If the md5sum of the dest file is the same as lastsum, replace the # destfile, saying we are replacing old config files if [ "$destsum" = "$lastsum" ]; then if [ "X$force_conffold" = "X" ]; then echo >&2 "Replacing config file $dest_file with new version" replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi else # b: If the md5sum of the dest file differs from lastsum, we need to ask # the user what action to take. if [ "X$force_conffnew" != "X" ]; then echo >&2 "Replacing config file $dest_file with new version" echo >&2 "since you asked for it." if [ "$destsum" = "$newsum" ]; then echo >&2 "The new and the old files are identical, AFAICS" else echo >&2 "The new and the old files are different" fi replace_conf_file; exit 0; fi if [ "X$force_conffold" != "X" ]; then replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi # c: If the destination file is the same as the new maintianer provided one, # we need do nothing. if [ "$newsum" = "$destsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums of the file in place matches, nothing needs be done." fi replace_md5sum; exit 0; # Hah. Match. We are done. fi done='NO'; while [ "X$done" = "XNO" ]; do if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then # Use debconf to prompt. if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then templ=ucf/changeprompt_threeway else templ=ucf/changeprompt fi if [ "X$override_template" != "X" ]; then choices="$(db_metaget $templ Choices-C)" choices2="$(db_metaget $override_template Choices-C)" if [ "$choices" = "$choices2" ]; then templ=$override_template fi fi db_fset "$templ" seen false db_reset "$templ" db_subst "$templ" FILE "$dest_file" db_subst "$templ" NEW "$new_file" db_subst "$templ" BASENAME "$(basename $dest_file)" db_input critical "$templ" || true if ! db_go; then # The current ucf interface does not provide a way for it # to tell its caller that the user chose to back up. # However, we could get here, if the caller turned on # debconf's backup capb. The best thing to do seems to be # to ignore requests to back up. continue fi db_get "$templ" ANSWER="$RET" else echo >&2 "Need debconf to interact" exit 2 ######################################################################################## # # Prompt without using debconf. # # cat >&2 <<EOPRMT # # Configuration file \`$dest_file' # # ==> File on system created by you or by a script. # # ==> File also in package provided by package maintainer. # # What would you like to do about it ? Your options are: # # Y or I : install the package maintainer's version # # N or O : keep your currently-installed version # # D : show the differences between the versions # # S : show the side-by-side differences between the versions # # EOPRMT # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # cat >&2 <<EOTD # # 3 or T : show a three way difference between current, older, # # and new versions of the file # # M : Do a 3 way merge between current, older, # # and new versions of the file [Very Experimental] # # EOTD # # fi # # cat >&2 <<EOPEND # # Z : start a new shell to examine the situation # # The default action is to keep your current version. # # EOPEND # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/3/T/M/Z) [default=N] ?" # # else # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/Z) [default=N] ?" # # fi # # read -e ANSWER </dev/tty # ######################################################################################## fi case "$ANSWER" in install_new|y|Y|I|i) echo >&2 "Replacing config file $dest_file with new version" RETAIN_OLD=YES replace_conf_file; exit 0; ;; diff|D|d) DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" ;; sdiff|S|s) DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")" show_diff "$DIFF" ;; diff_threeway|3|t|T) if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then if [ -e "$dest_file" ]; then DIFF="$(diff3 -L Current -L Older -L New -A \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file")" || true else DIFF="$(diff3 -L Current -L Older -L New -A \ /dev/null "$statedir/cache/$cached_file" \ "$new_file")" || true fi show_diff "$DIFF" else DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" fi ;; merge_threeway|M|m) echo >&2 "Merging changes into the new version" if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then ret=0 diff3 -L Current -L Older -L New -m \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$? case "$ret" in 0) new_file="$dest_file.${NEW_SUFFIX}" RETAIN_OLD=YES replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 ;; *) mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}" db_subst ucf/conflicts_found dest_file "$dest_file" db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}" db_input critical ucf/conflicts_found || true db_go || true ;; esac else replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 fi ;; shell|Z|z) # We explicitly connect STDIN and STDOUT to the # script's controlling terminal, so even if STDIN is # fed by a pipe, as is the case when run from # /usr/bin/debconf, the shell should be fully # functional. However, the test for a controlling # terminal uses /usr/bin/tty, which consults only # STDIN. As far as I can tell, when run from debconf, # ucf will _never_ use the current terminal. If the # goal is to check for access to a terminal, the test # should be for foreground process group membership, # not a terminal connected to STDIN (tty -s), and not # a terminal it doesn't necessarily own (tty -s # </dev/tty). The easiest way do this from a shell is # probably with /bin/ps. if ps -o stat= --ppid $$ | grep -q '+'; then export UCF_CONFFILE_OLD="$dest_file" export UCF_CONFFILE_NEW="$new_file" bash >/dev/tty </dev/tty || true elif [ -n "$DISPLAY" ]; then x-terminal-emulator || true else # Don't know what to do echo >&2 "No terminal, and no DISPLAY set, can't fork shell." sleep 3; fi ;; keep_current|n|N|o|O|'') replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; ;; *) if [ "$DEBCONF_OK" = "YES" ]; then echo "Error: unknown response from debconf:'$RET'" >&2 exit 1 else echo echo "Please answer with one of the single letters listed." >&2 echo fi esac done fi db_stop exit 0;
Close